'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dropdown = require('./Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _MenuItem = require('./MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _SplitToggle = require('./SplitToggle');

var _SplitToggle2 = _interopRequireDefault(_SplitToggle);

var _lodashCompatObjectOmit = require('lodash-compat/object/omit');

var _lodashCompatObjectOmit2 = _interopRequireDefault(_lodashCompatObjectOmit);

var _lodashCompatObjectPick = require('lodash-compat/object/pick');

var _lodashCompatObjectPick2 = _interopRequireDefault(_lodashCompatObjectPick);

var Select = _react2['default'].createClass({
  displayName: 'Select',

  allItems: [],
  getInitialState: function getInitialState() {
    return {
      selectText: '', // 显示的项
      selectOption: {
        value: this.props.value,
        text: ''
      },
      activeItems: [], // 所有显示的选项
      selectIndex: this.props.selectIndex || -1 // 选中的第几项 
    };
  },
  componentWillMount: function componentWillMount() {
    var _this2 = this;

    // 初始化的时候，存储全部数据下拉列表数据, 并设置默认选中项
    var props = this.props,
        children = [],
        _this = this;

    this.allItems = [];
    props.children.map(function (item) {
      if (item instanceof Array) {
        children = children.concat(item);
      } else {
        children.push(item);
      }
    });
    children.map(function (item, index) {
      _this2.allItems.push({
        value: item.props.value,
        text: item.props.children
      });
      if (props.value != undefined && props.value == item.props.value) {
        _this.state.selectIndex = index;
        _this.state.selectText = item.props.children;
        _this.state.selectOption = {
          value: props.value,
          text: item.props.children
        };
      }
      if (props.selectIndex != undefined && props.selectIndex == index) {
        _this.state.selectIndex = index;
        _this.state.selectText = item.props.children;
        _this.state.selectOption = {
          value: item.props.value,
          text: item.props.children
        };
      }
    });
    // 默认显示为 所加载的全部内容
    this.state.activeItems = this.allItems;
  },
  render: function render() {
    var _this3 = this;

    var _props = this.props;
    var bsSize = _props.bsSize;
    var bsStyle = _props.bsStyle;

    var props = _objectWithoutProperties(_props, ['bsSize', 'bsStyle']);

    var dropdownProps = _lodashCompatObjectPick2['default'](props, _Object$keys(_Dropdown2['default'].ControlledComponent.propTypes));
    var buttonProps = _lodashCompatObjectOmit2['default'](props, _Object$keys(_Dropdown2['default'].ControlledComponent.propTypes));

    return _react2['default'].createElement(
      _Dropdown2['default'],
      _extends({}, dropdownProps, { key: this.props.name, className: 'select-dropdown', onClose: this.onHandClose }),
      _react2['default'].createElement(
        _Dropdown2['default'].Toggle,
        {
          noCaret: true,
          style: { width: this.props.width },
          title: this.state.selectText,
          className: 'selectText',
          useAnchor: true
        },
        _react2['default'].createElement('input', { value: this.state.selectText, style: { width: this.props.width }, onChange: this.onHandChange })
      ),
      _react2['default'].createElement(_Dropdown2['default'].Toggle, _extends({
        className: 'select-btn'
      }, buttonProps, {
        disabled: false,
        width: 26
      })),
      _react2['default'].createElement('input', { type: 'hidden', value: this.state.selectOption.value, 'data-text': this.state.selectOption.text, ref: 'selectInput' }),
      _react2['default'].createElement(
        _Dropdown2['default'].Menu,
        { style: { width: this.props.width + 25, maxHeight: this.props.maxHeight, overflowY: 'auto' } },
        this.state.activeItems && this.state.activeItems.length > 0 ? this.state.activeItems.map(function (item, index) {
          return _react2['default'].createElement(
            _MenuItem2['default'],
            { eventKey: index, key: index, active: index == _this3.state.selectIndex ? true : false, onClick: _this3.selectItem.bind(_this3, index, item) },
            item.text
          );
        }) : _react2['default'].createElement(
          'li',
          { className: 'nodata' },
          _react2['default'].createElement(
            'div',
            null,
            this.props.noSearchDataTips
          )
        )
      )
    );
  },
  selectItem: function selectItem(index, item, e) {
    e.stopPropagation();
    var selectOption = {
      value: item.value,
      text: item.text
    };

    this.setState(_extends({}, this.state, {
      selectText: item.text,
      selectIndex: index,
      selectOption: selectOption
    }));
    // 回调onSelect 事件
    this.props.onSelected(selectOption);
  },
  onHandChange: function onHandChange(e) {
    var _this4 = this;

    if (this.props.openSearch) {
      (function () {
        e.stopPropagation();
        // 获取到输入的值，筛选到匹配的列表项
        var sinput = e.target.value,
            grepItems = _this4.allItems.filter(function (item) {
          return item.text.indexOf(sinput) > -1;
        }),
            selectIndex = -1;

        // 重新匹配是否有选中
        grepItems.map(function (item, index) {
          if (_this4.state.selectOption.value == item.value) {
            return selectIndex = index;
          }
        });

        _this4.setState(_extends({}, _this4.state, {
          selectText: sinput,
          selectIndex: selectIndex,
          activeItems: grepItems
        }));
      })();
    }
  },
  onHandClose: function onHandClose() {
    var _this5 = this;

    if (this.props.openSearch) {
      // 没有手动选中的情况，恢复到上次选中
      var selectIndex = -1;
      this.allItems.map(function (item, index) {
        if (_this5.state.selectOption.value == item.value) {
          return selectIndex = index;
        }
      });
      this.setState(_extends({}, this.state, {
        selectIndex: selectIndex,
        selectText: this.state.selectOption.text,
        activeItems: this.allItems
      }));
    }
  }
});

Select.propTypes = {
  /**
   * 默认选中的项value值
   */
  value: _react2['default'].PropTypes.string,
  /**
   * 宽度
   */
  width: _react2['default'].PropTypes.number,
  /**
   * 默认选中项
   */
  selectIndex: _react2['default'].PropTypes.number,
  /**
   * onSelected 事件
   */
  onSelected: _react2['default'].PropTypes.func,
  /**
   * maxHeight 最大高度
   */
  maxHeight: _react2['default'].PropTypes.number,
  /**
   * noSeachTips 没有找到查询相关记录的提示
   */
  noSearchDataTips: _react2['default'].PropTypes.string,
  /**
   *  是否开启查询功能
   */
  openSearch: _react2['default'].PropTypes.bool
};

Select.defaultProps = {
  noSearchDataTips: '没有找到相关数据',
  openSearch: false,
  width: 200,
  maxHeight: 180
};
exports['default'] = Select;
module.exports = exports['default'];